<template>
    <!-- v-if 如果当前的路由hidden不为true (也就是应该在菜单栏显示) -->
    <div class="menu-wrapper" v-if="!item.hidden">
        <!-- 1.当我只有1个子路由 并且子路由没有孙级路由。
             2.如果我只有1个子路由并且子级路由下都是hidden为true 
             3.如果我没有子级路由 只有我当前这一层
             4.并且我不是总显示在根路由
             那么在左侧菜单栏都是只有一层的 点击就跳转
        -->
        <template
            v-if="hasOneShowingChild(item.children, item) && (!onlyOneChild.children || onlyOneChild.noShowingChildren) && !item.alwaysShow"
        >
            <el-menu-item :index="resolvePath(onlyOneChild.path)">
                <!-- <item :icon="onlyOneChild.meta.icon || (item.meta && item.meta.icon)" :title="onlyOneChild.meta.title" /> 存疑-->
                <i
                    :class="onlyOneChild.meta.icon"
                    v-if="(onlyOneChild.meta && onlyOneChild.meta.icon) || (item.meta && item.meta.icon)"
                ></i>
                <span slot="title" v-if="onlyOneChild.meta">{{ onlyOneChild.meta.title }}</span>
            </el-menu-item>
        </template>
        <!-- 否则就是层级不止一层 需要使用el-submenu -->
        <el-submenu v-else ref="subMenu" :index="resolvePath(item.path)">
            <template slot="title">
                <!-- <item v-if="item.meta" :icon="item.meta && item.meta.icon" :title="item.meta.title" /> -->
                <i  v-if="item.meta && item.meta.icon" :class="item.meta.icon"></i>
                <span>{{ item.meta.title }}</span>
            </template>

            <!-- 递归  只有不止一层时才需要递归 base-path如果不写点击不了 需要修改resolvePath-->
            <SidebarItem
                v-for="child in item.children"
                :key="child.path"
                :item="child"
                :base-path="resolvePath(child.path)"
                class="nest-menu"
            ></SidebarItem>
        </el-submenu>
    </div>
</template>
<script>
import { isExternal } from '../../utils/validate';
import path from 'path'; // path是用来干嘛的
export default {
    name: 'SidebarItem',
    props: {
        // route object
        item: {
            type: Object,
            required: true,
        },
        isNest: {
            type: Boolean,
            default: false,
        },
        basePath: {
            type: String,
            default: '',
        },
    },
    data() {
        return {
            onlyOneChild: null,
        };
    },
    methods: {
        /**
         * 当前路由是否只有一个子路由 也就是是否是一级菜单
         */
        hasOneShowingChild(children = [], parent) {
            // 检测当前路由下有几个children显示
            const showingChildren = children.filter(item => {
                if (item.hidden) {
                    return false;
                } else {
                    // Temp set(will be used if only has one showing child)
                    this.onlyOneChild = item;
                    return true;
                }
            });
            // 当只有一个子路由时，默认显示子路由器
            if (showingChildren.length === 1) {
                return true;
            }
            // 如果没有需要显示的子路由，则显示当前路由的路径
            if (showingChildren.length === 0) {
                this.onlyOneChild = { ...parent, path: '', noShowingChildren: true };
                return true;
            }
            // 不止1个子路由要显示则return false
            return false;
        },
        /**
         * 存疑？？这个是干嘛的
         */
        resolvePath(routePath) {
            if (isExternal(routePath)) {
                return routePath;
            }
            if (isExternal(this.basePath)) {
                return this.basePath;
            }
            return path.resolve(this.basePath, routePath);
        },
    },
};
</script>
<style  scoped>

</style>
